Package org.apache.sysds.parser.dml

## Class DmlBaseListener

- java.lang.Object
- - org.apache.sysds.parser.dml.DmlBaseListener

- All Implemented Interfaces:
    `org.antlr.v4.runtime.tree.ParseTreeListener`, `DmlListener`

      public class DmlBaseListener
      extends Object
      implements DmlListener

  This class provides an empty implementation of `DmlListener`, which can be extended to create a listener which only needs to handle a subset of the available methods.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DmlBaseListener()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `enterAccumulatorAssignmentStatement​(DmlParser.AccumulatorAssignmentStatementContext ctx)` | Enter a parse tree produced by the `AccumulatorAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterAddSubExpression​(DmlParser.AddSubExpressionContext ctx)` | Enter a parse tree produced by the `AddSubExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterAssignmentStatement​(DmlParser.AssignmentStatementContext ctx)` | Enter a parse tree produced by the `AssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterAtomicExpression​(DmlParser.AtomicExpressionContext ctx)` | Enter a parse tree produced by the `AtomicExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterBooleanAndExpression​(DmlParser.BooleanAndExpressionContext ctx)` | Enter a parse tree produced by the `BooleanAndExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterBooleanNotExpression​(DmlParser.BooleanNotExpressionContext ctx)` | Enter a parse tree produced by the `BooleanNotExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterBooleanOrExpression​(DmlParser.BooleanOrExpressionContext ctx)` | Enter a parse tree produced by the `BooleanOrExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterBuiltinFunctionExpression​(DmlParser.BuiltinFunctionExpressionContext ctx)` | Enter a parse tree produced by the `BuiltinFunctionExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterCommandlineParamExpression​(DmlParser.CommandlineParamExpressionContext ctx)` | Enter a parse tree produced by the `CommandlineParamExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `enterCommandlinePositionExpression​(DmlParser.CommandlinePositionExpressionContext ctx)` | Enter a parse tree produced by the `CommandlinePositionExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `enterConstDoubleIdExpression​(DmlParser.ConstDoubleIdExpressionContext ctx)` | Enter a parse tree produced by the `ConstDoubleIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterConstFalseExpression​(DmlParser.ConstFalseExpressionContext ctx)` | Enter a parse tree produced by the `ConstFalseExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterConstIntIdExpression​(DmlParser.ConstIntIdExpressionContext ctx)` | Enter a parse tree produced by the `ConstIntIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterConstStringIdExpression​(DmlParser.ConstStringIdExpressionContext ctx)` | Enter a parse tree produced by the `ConstStringIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterConstTrueExpression​(DmlParser.ConstTrueExpressionContext ctx)` | Enter a parse tree produced by the `ConstTrueExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterDataIdExpression​(DmlParser.DataIdExpressionContext ctx)` | Enter a parse tree produced by the `DataIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterEveryRule​(org.antlr.v4.runtime.ParserRuleContext ctx)`
    `void` | `enterExternalFunctionDefExpression​(DmlParser.ExternalFunctionDefExpressionContext ctx)` | Enter a parse tree produced by the `ExternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.
    `void` | `enterForStatement​(DmlParser.ForStatementContext ctx)` | Enter a parse tree produced by the `ForStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterFunctionCallAssignmentStatement​(DmlParser.FunctionCallAssignmentStatementContext ctx)` | Enter a parse tree produced by the `FunctionCallAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterFunctionCallMultiAssignmentStatement​(DmlParser.FunctionCallMultiAssignmentStatementContext ctx)` | Enter a parse tree produced by the `FunctionCallMultiAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterIfdefAssignmentStatement​(DmlParser.IfdefAssignmentStatementContext ctx)` | Enter a parse tree produced by the `IfdefAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterIfStatement​(DmlParser.IfStatementContext ctx)` | Enter a parse tree produced by the `IfStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterImportStatement​(DmlParser.ImportStatementContext ctx)` | Enter a parse tree produced by the `ImportStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterIndexedExpression​(DmlParser.IndexedExpressionContext ctx)` | Enter a parse tree produced by the `IndexedExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `enterInternalFunctionDefExpression​(DmlParser.InternalFunctionDefExpressionContext ctx)` | Enter a parse tree produced by the `InternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.
    `void` | `enterIterablePredicateColonExpression​(DmlParser.IterablePredicateColonExpressionContext ctx)` | Enter a parse tree produced by the `IterablePredicateColonExpression` labeled alternative in `DmlParser.iterablePredicate()`.
    `void` | `enterIterablePredicateSeqExpression​(DmlParser.IterablePredicateSeqExpressionContext ctx)` | Enter a parse tree produced by the `IterablePredicateSeqExpression` labeled alternative in `DmlParser.iterablePredicate()`.
    `void` | `enterMatrixDataTypeCheck​(DmlParser.MatrixDataTypeCheckContext ctx)` | Enter a parse tree produced by the `MatrixDataTypeCheck` labeled alternative in `DmlParser.dataType()`.
    `void` | `enterMatrixMulExpression​(DmlParser.MatrixMulExpressionContext ctx)` | Enter a parse tree produced by the `MatrixMulExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterMl_type​(DmlParser.Ml_typeContext ctx)` | Enter a parse tree produced by `DmlParser.ml_type()`.
    `void` | `enterModIntDivExpression​(DmlParser.ModIntDivExpressionContext ctx)` | Enter a parse tree produced by the `ModIntDivExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterMultDivExpression​(DmlParser.MultDivExpressionContext ctx)` | Enter a parse tree produced by the `MultDivExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterMultiIdExpression​(DmlParser.MultiIdExpressionContext ctx)` | Enter a parse tree produced by the `MultiIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterParameterizedExpression​(DmlParser.ParameterizedExpressionContext ctx)` | Enter a parse tree produced by `DmlParser.parameterizedExpression()`.
    `void` | `enterParForStatement​(DmlParser.ParForStatementContext ctx)` | Enter a parse tree produced by the `ParForStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterPathStatement​(DmlParser.PathStatementContext ctx)` | Enter a parse tree produced by the `PathStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterPowerExpression​(DmlParser.PowerExpressionContext ctx)` | Enter a parse tree produced by the `PowerExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterProgramroot​(DmlParser.ProgramrootContext ctx)` | Enter a parse tree produced by `DmlParser.programroot()`.
    `void` | `enterRelationalExpression​(DmlParser.RelationalExpressionContext ctx)` | Enter a parse tree produced by the `RelationalExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterSimpleDataIdentifierExpression​(DmlParser.SimpleDataIdentifierExpressionContext ctx)` | Enter a parse tree produced by the `SimpleDataIdentifierExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `enterStrictParameterizedExpression​(DmlParser.StrictParameterizedExpressionContext ctx)` | Enter a parse tree produced by `DmlParser.strictParameterizedExpression()`.
    `void` | `enterStrictParameterizedKeyValueString​(DmlParser.StrictParameterizedKeyValueStringContext ctx)` | Enter a parse tree produced by `DmlParser.strictParameterizedKeyValueString()`.
    `void` | `enterTypedArgAssign​(DmlParser.TypedArgAssignContext ctx)` | Enter a parse tree produced by `DmlParser.typedArgAssign()`.
    `void` | `enterTypedArgNoAssign​(DmlParser.TypedArgNoAssignContext ctx)` | Enter a parse tree produced by `DmlParser.typedArgNoAssign()`.
    `void` | `enterUnaryExpression​(DmlParser.UnaryExpressionContext ctx)` | Enter a parse tree produced by the `UnaryExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterValueType​(DmlParser.ValueTypeContext ctx)` | Enter a parse tree produced by `DmlParser.valueType()`.
    `void` | `enterWhileStatement​(DmlParser.WhileStatementContext ctx)` | Enter a parse tree produced by the `WhileStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitAccumulatorAssignmentStatement​(DmlParser.AccumulatorAssignmentStatementContext ctx)` | Exit a parse tree produced by the `AccumulatorAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitAddSubExpression​(DmlParser.AddSubExpressionContext ctx)` | Exit a parse tree produced by the `AddSubExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitAssignmentStatement​(DmlParser.AssignmentStatementContext ctx)` | Exit a parse tree produced by the `AssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitAtomicExpression​(DmlParser.AtomicExpressionContext ctx)` | Exit a parse tree produced by the `AtomicExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitBooleanAndExpression​(DmlParser.BooleanAndExpressionContext ctx)` | Exit a parse tree produced by the `BooleanAndExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitBooleanNotExpression​(DmlParser.BooleanNotExpressionContext ctx)` | Exit a parse tree produced by the `BooleanNotExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitBooleanOrExpression​(DmlParser.BooleanOrExpressionContext ctx)` | Exit a parse tree produced by the `BooleanOrExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitBuiltinFunctionExpression​(DmlParser.BuiltinFunctionExpressionContext ctx)` | Exit a parse tree produced by the `BuiltinFunctionExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitCommandlineParamExpression​(DmlParser.CommandlineParamExpressionContext ctx)` | Exit a parse tree produced by the `CommandlineParamExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `exitCommandlinePositionExpression​(DmlParser.CommandlinePositionExpressionContext ctx)` | Exit a parse tree produced by the `CommandlinePositionExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `exitConstDoubleIdExpression​(DmlParser.ConstDoubleIdExpressionContext ctx)` | Exit a parse tree produced by the `ConstDoubleIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitConstFalseExpression​(DmlParser.ConstFalseExpressionContext ctx)` | Exit a parse tree produced by the `ConstFalseExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitConstIntIdExpression​(DmlParser.ConstIntIdExpressionContext ctx)` | Exit a parse tree produced by the `ConstIntIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitConstStringIdExpression​(DmlParser.ConstStringIdExpressionContext ctx)` | Exit a parse tree produced by the `ConstStringIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitConstTrueExpression​(DmlParser.ConstTrueExpressionContext ctx)` | Exit a parse tree produced by the `ConstTrueExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitDataIdExpression​(DmlParser.DataIdExpressionContext ctx)` | Exit a parse tree produced by the `DataIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitEveryRule​(org.antlr.v4.runtime.ParserRuleContext ctx)`
    `void` | `exitExternalFunctionDefExpression​(DmlParser.ExternalFunctionDefExpressionContext ctx)` | Exit a parse tree produced by the `ExternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.
    `void` | `exitForStatement​(DmlParser.ForStatementContext ctx)` | Exit a parse tree produced by the `ForStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitFunctionCallAssignmentStatement​(DmlParser.FunctionCallAssignmentStatementContext ctx)` | Exit a parse tree produced by the `FunctionCallAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitFunctionCallMultiAssignmentStatement​(DmlParser.FunctionCallMultiAssignmentStatementContext ctx)` | Exit a parse tree produced by the `FunctionCallMultiAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitIfdefAssignmentStatement​(DmlParser.IfdefAssignmentStatementContext ctx)` | Exit a parse tree produced by the `IfdefAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitIfStatement​(DmlParser.IfStatementContext ctx)` | Exit a parse tree produced by the `IfStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitImportStatement​(DmlParser.ImportStatementContext ctx)` | Exit a parse tree produced by the `ImportStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitIndexedExpression​(DmlParser.IndexedExpressionContext ctx)` | Exit a parse tree produced by the `IndexedExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `exitInternalFunctionDefExpression​(DmlParser.InternalFunctionDefExpressionContext ctx)` | Exit a parse tree produced by the `InternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.
    `void` | `exitIterablePredicateColonExpression​(DmlParser.IterablePredicateColonExpressionContext ctx)` | Exit a parse tree produced by the `IterablePredicateColonExpression` labeled alternative in `DmlParser.iterablePredicate()`.
    `void` | `exitIterablePredicateSeqExpression​(DmlParser.IterablePredicateSeqExpressionContext ctx)` | Exit a parse tree produced by the `IterablePredicateSeqExpression` labeled alternative in `DmlParser.iterablePredicate()`.
    `void` | `exitMatrixDataTypeCheck​(DmlParser.MatrixDataTypeCheckContext ctx)` | Exit a parse tree produced by the `MatrixDataTypeCheck` labeled alternative in `DmlParser.dataType()`.
    `void` | `exitMatrixMulExpression​(DmlParser.MatrixMulExpressionContext ctx)` | Exit a parse tree produced by the `MatrixMulExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitMl_type​(DmlParser.Ml_typeContext ctx)` | Exit a parse tree produced by `DmlParser.ml_type()`.
    `void` | `exitModIntDivExpression​(DmlParser.ModIntDivExpressionContext ctx)` | Exit a parse tree produced by the `ModIntDivExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitMultDivExpression​(DmlParser.MultDivExpressionContext ctx)` | Exit a parse tree produced by the `MultDivExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitMultiIdExpression​(DmlParser.MultiIdExpressionContext ctx)` | Exit a parse tree produced by the `MultiIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitParameterizedExpression​(DmlParser.ParameterizedExpressionContext ctx)` | Exit a parse tree produced by `DmlParser.parameterizedExpression()`.
    `void` | `exitParForStatement​(DmlParser.ParForStatementContext ctx)` | Exit a parse tree produced by the `ParForStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitPathStatement​(DmlParser.PathStatementContext ctx)` | Exit a parse tree produced by the `PathStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitPowerExpression​(DmlParser.PowerExpressionContext ctx)` | Exit a parse tree produced by the `PowerExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitProgramroot​(DmlParser.ProgramrootContext ctx)` | Exit a parse tree produced by `DmlParser.programroot()`.
    `void` | `exitRelationalExpression​(DmlParser.RelationalExpressionContext ctx)` | Exit a parse tree produced by the `RelationalExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitSimpleDataIdentifierExpression​(DmlParser.SimpleDataIdentifierExpressionContext ctx)` | Exit a parse tree produced by the `SimpleDataIdentifierExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `exitStrictParameterizedExpression​(DmlParser.StrictParameterizedExpressionContext ctx)` | Exit a parse tree produced by `DmlParser.strictParameterizedExpression()`.
    `void` | `exitStrictParameterizedKeyValueString​(DmlParser.StrictParameterizedKeyValueStringContext ctx)` | Exit a parse tree produced by `DmlParser.strictParameterizedKeyValueString()`.
    `void` | `exitTypedArgAssign​(DmlParser.TypedArgAssignContext ctx)` | Exit a parse tree produced by `DmlParser.typedArgAssign()`.
    `void` | `exitTypedArgNoAssign​(DmlParser.TypedArgNoAssignContext ctx)` | Exit a parse tree produced by `DmlParser.typedArgNoAssign()`.
    `void` | `exitUnaryExpression​(DmlParser.UnaryExpressionContext ctx)` | Exit a parse tree produced by the `UnaryExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitValueType​(DmlParser.ValueTypeContext ctx)` | Exit a parse tree produced by `DmlParser.valueType()`.
    `void` | `exitWhileStatement​(DmlParser.WhileStatementContext ctx)` | Exit a parse tree produced by the `WhileStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `visitErrorNode​(org.antlr.v4.runtime.tree.ErrorNode node)`
    `void` | `visitTerminal​(org.antlr.v4.runtime.tree.TerminalNode node)`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DmlBaseListener

          public DmlBaseListener()

  - ### Method Detail

    - #### enterProgramroot

          public void enterProgramroot​(DmlParser.ProgramrootContext ctx)

      Enter a parse tree produced by `DmlParser.programroot()`.

      The default implementation does nothing.

      Specified by:
        `enterProgramroot` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitProgramroot

          public void exitProgramroot​(DmlParser.ProgramrootContext ctx)

      Exit a parse tree produced by `DmlParser.programroot()`.

      The default implementation does nothing.

      Specified by:
        `exitProgramroot` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterImportStatement

          public void enterImportStatement​(DmlParser.ImportStatementContext ctx)

      Enter a parse tree produced by the `ImportStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `enterImportStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitImportStatement

          public void exitImportStatement​(DmlParser.ImportStatementContext ctx)

      Exit a parse tree produced by the `ImportStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `exitImportStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterPathStatement

          public void enterPathStatement​(DmlParser.PathStatementContext ctx)

      Enter a parse tree produced by the `PathStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `enterPathStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitPathStatement

          public void exitPathStatement​(DmlParser.PathStatementContext ctx)

      Exit a parse tree produced by the `PathStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `exitPathStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterFunctionCallAssignmentStatement

          public void enterFunctionCallAssignmentStatement​(DmlParser.FunctionCallAssignmentStatementContext ctx)

      Enter a parse tree produced by the `FunctionCallAssignmentStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `enterFunctionCallAssignmentStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitFunctionCallAssignmentStatement

          public void exitFunctionCallAssignmentStatement​(DmlParser.FunctionCallAssignmentStatementContext ctx)

      Exit a parse tree produced by the `FunctionCallAssignmentStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `exitFunctionCallAssignmentStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterFunctionCallMultiAssignmentStatement

          public void enterFunctionCallMultiAssignmentStatement​(DmlParser.FunctionCallMultiAssignmentStatementContext ctx)

      Enter a parse tree produced by the `FunctionCallMultiAssignmentStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `enterFunctionCallMultiAssignmentStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitFunctionCallMultiAssignmentStatement

          public void exitFunctionCallMultiAssignmentStatement​(DmlParser.FunctionCallMultiAssignmentStatementContext ctx)

      Exit a parse tree produced by the `FunctionCallMultiAssignmentStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `exitFunctionCallMultiAssignmentStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterIfdefAssignmentStatement

          public void enterIfdefAssignmentStatement​(DmlParser.IfdefAssignmentStatementContext ctx)

      Enter a parse tree produced by the `IfdefAssignmentStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `enterIfdefAssignmentStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitIfdefAssignmentStatement

          public void exitIfdefAssignmentStatement​(DmlParser.IfdefAssignmentStatementContext ctx)

      Exit a parse tree produced by the `IfdefAssignmentStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `exitIfdefAssignmentStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterAssignmentStatement

          public void enterAssignmentStatement​(DmlParser.AssignmentStatementContext ctx)

      Enter a parse tree produced by the `AssignmentStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `enterAssignmentStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitAssignmentStatement

          public void exitAssignmentStatement​(DmlParser.AssignmentStatementContext ctx)

      Exit a parse tree produced by the `AssignmentStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `exitAssignmentStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterAccumulatorAssignmentStatement

          public void enterAccumulatorAssignmentStatement​(DmlParser.AccumulatorAssignmentStatementContext ctx)

      Enter a parse tree produced by the `AccumulatorAssignmentStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `enterAccumulatorAssignmentStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitAccumulatorAssignmentStatement

          public void exitAccumulatorAssignmentStatement​(DmlParser.AccumulatorAssignmentStatementContext ctx)

      Exit a parse tree produced by the `AccumulatorAssignmentStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `exitAccumulatorAssignmentStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterIfStatement

          public void enterIfStatement​(DmlParser.IfStatementContext ctx)

      Enter a parse tree produced by the `IfStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `enterIfStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitIfStatement

          public void exitIfStatement​(DmlParser.IfStatementContext ctx)

      Exit a parse tree produced by the `IfStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `exitIfStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterForStatement

          public void enterForStatement​(DmlParser.ForStatementContext ctx)

      Enter a parse tree produced by the `ForStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `enterForStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitForStatement

          public void exitForStatement​(DmlParser.ForStatementContext ctx)

      Exit a parse tree produced by the `ForStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `exitForStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterParForStatement

          public void enterParForStatement​(DmlParser.ParForStatementContext ctx)

      Enter a parse tree produced by the `ParForStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `enterParForStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitParForStatement

          public void exitParForStatement​(DmlParser.ParForStatementContext ctx)

      Exit a parse tree produced by the `ParForStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `exitParForStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterWhileStatement

          public void enterWhileStatement​(DmlParser.WhileStatementContext ctx)

      Enter a parse tree produced by the `WhileStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `enterWhileStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitWhileStatement

          public void exitWhileStatement​(DmlParser.WhileStatementContext ctx)

      Exit a parse tree produced by the `WhileStatement` labeled alternative in `DmlParser.statement()`.

      The default implementation does nothing.

      Specified by:
        `exitWhileStatement` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterIterablePredicateColonExpression

          public void enterIterablePredicateColonExpression​(DmlParser.IterablePredicateColonExpressionContext ctx)

      Enter a parse tree produced by the `IterablePredicateColonExpression` labeled alternative in `DmlParser.iterablePredicate()`.

      The default implementation does nothing.

      Specified by:
        `enterIterablePredicateColonExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitIterablePredicateColonExpression

          public void exitIterablePredicateColonExpression​(DmlParser.IterablePredicateColonExpressionContext ctx)

      Exit a parse tree produced by the `IterablePredicateColonExpression` labeled alternative in `DmlParser.iterablePredicate()`.

      The default implementation does nothing.

      Specified by:
        `exitIterablePredicateColonExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterIterablePredicateSeqExpression

          public void enterIterablePredicateSeqExpression​(DmlParser.IterablePredicateSeqExpressionContext ctx)

      Enter a parse tree produced by the `IterablePredicateSeqExpression` labeled alternative in `DmlParser.iterablePredicate()`.

      The default implementation does nothing.

      Specified by:
        `enterIterablePredicateSeqExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitIterablePredicateSeqExpression

          public void exitIterablePredicateSeqExpression​(DmlParser.IterablePredicateSeqExpressionContext ctx)

      Exit a parse tree produced by the `IterablePredicateSeqExpression` labeled alternative in `DmlParser.iterablePredicate()`.

      The default implementation does nothing.

      Specified by:
        `exitIterablePredicateSeqExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterInternalFunctionDefExpression

          public void enterInternalFunctionDefExpression​(DmlParser.InternalFunctionDefExpressionContext ctx)

      Enter a parse tree produced by the `InternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.

      The default implementation does nothing.

      Specified by:
        `enterInternalFunctionDefExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitInternalFunctionDefExpression

          public void exitInternalFunctionDefExpression​(DmlParser.InternalFunctionDefExpressionContext ctx)

      Exit a parse tree produced by the `InternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.

      The default implementation does nothing.

      Specified by:
        `exitInternalFunctionDefExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterExternalFunctionDefExpression

          public void enterExternalFunctionDefExpression​(DmlParser.ExternalFunctionDefExpressionContext ctx)

      Enter a parse tree produced by the `ExternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.

      The default implementation does nothing.

      Specified by:
        `enterExternalFunctionDefExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitExternalFunctionDefExpression

          public void exitExternalFunctionDefExpression​(DmlParser.ExternalFunctionDefExpressionContext ctx)

      Exit a parse tree produced by the `ExternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.

      The default implementation does nothing.

      Specified by:
        `exitExternalFunctionDefExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterIndexedExpression

          public void enterIndexedExpression​(DmlParser.IndexedExpressionContext ctx)

      Enter a parse tree produced by the `IndexedExpression` labeled alternative in `DmlParser.dataIdentifier()`.

      The default implementation does nothing.

      Specified by:
        `enterIndexedExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitIndexedExpression

          public void exitIndexedExpression​(DmlParser.IndexedExpressionContext ctx)

      Exit a parse tree produced by the `IndexedExpression` labeled alternative in `DmlParser.dataIdentifier()`.

      The default implementation does nothing.

      Specified by:
        `exitIndexedExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterSimpleDataIdentifierExpression

          public void enterSimpleDataIdentifierExpression​(DmlParser.SimpleDataIdentifierExpressionContext ctx)

      Enter a parse tree produced by the `SimpleDataIdentifierExpression` labeled alternative in `DmlParser.dataIdentifier()`.

      The default implementation does nothing.

      Specified by:
        `enterSimpleDataIdentifierExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitSimpleDataIdentifierExpression

          public void exitSimpleDataIdentifierExpression​(DmlParser.SimpleDataIdentifierExpressionContext ctx)

      Exit a parse tree produced by the `SimpleDataIdentifierExpression` labeled alternative in `DmlParser.dataIdentifier()`.

      The default implementation does nothing.

      Specified by:
        `exitSimpleDataIdentifierExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterCommandlineParamExpression

          public void enterCommandlineParamExpression​(DmlParser.CommandlineParamExpressionContext ctx)

      Enter a parse tree produced by the `CommandlineParamExpression` labeled alternative in `DmlParser.dataIdentifier()`.

      The default implementation does nothing.

      Specified by:
        `enterCommandlineParamExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitCommandlineParamExpression

          public void exitCommandlineParamExpression​(DmlParser.CommandlineParamExpressionContext ctx)

      Exit a parse tree produced by the `CommandlineParamExpression` labeled alternative in `DmlParser.dataIdentifier()`.

      The default implementation does nothing.

      Specified by:
        `exitCommandlineParamExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterCommandlinePositionExpression

          public void enterCommandlinePositionExpression​(DmlParser.CommandlinePositionExpressionContext ctx)

      Enter a parse tree produced by the `CommandlinePositionExpression` labeled alternative in `DmlParser.dataIdentifier()`.

      The default implementation does nothing.

      Specified by:
        `enterCommandlinePositionExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitCommandlinePositionExpression

          public void exitCommandlinePositionExpression​(DmlParser.CommandlinePositionExpressionContext ctx)

      Exit a parse tree produced by the `CommandlinePositionExpression` labeled alternative in `DmlParser.dataIdentifier()`.

      The default implementation does nothing.

      Specified by:
        `exitCommandlinePositionExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterModIntDivExpression

          public void enterModIntDivExpression​(DmlParser.ModIntDivExpressionContext ctx)

      Enter a parse tree produced by the `ModIntDivExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterModIntDivExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitModIntDivExpression

          public void exitModIntDivExpression​(DmlParser.ModIntDivExpressionContext ctx)

      Exit a parse tree produced by the `ModIntDivExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitModIntDivExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterRelationalExpression

          public void enterRelationalExpression​(DmlParser.RelationalExpressionContext ctx)

      Enter a parse tree produced by the `RelationalExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterRelationalExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitRelationalExpression

          public void exitRelationalExpression​(DmlParser.RelationalExpressionContext ctx)

      Exit a parse tree produced by the `RelationalExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitRelationalExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterBooleanNotExpression

          public void enterBooleanNotExpression​(DmlParser.BooleanNotExpressionContext ctx)

      Enter a parse tree produced by the `BooleanNotExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterBooleanNotExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitBooleanNotExpression

          public void exitBooleanNotExpression​(DmlParser.BooleanNotExpressionContext ctx)

      Exit a parse tree produced by the `BooleanNotExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitBooleanNotExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterPowerExpression

          public void enterPowerExpression​(DmlParser.PowerExpressionContext ctx)

      Enter a parse tree produced by the `PowerExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterPowerExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitPowerExpression

          public void exitPowerExpression​(DmlParser.PowerExpressionContext ctx)

      Exit a parse tree produced by the `PowerExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitPowerExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterBuiltinFunctionExpression

          public void enterBuiltinFunctionExpression​(DmlParser.BuiltinFunctionExpressionContext ctx)

      Enter a parse tree produced by the `BuiltinFunctionExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterBuiltinFunctionExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitBuiltinFunctionExpression

          public void exitBuiltinFunctionExpression​(DmlParser.BuiltinFunctionExpressionContext ctx)

      Exit a parse tree produced by the `BuiltinFunctionExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitBuiltinFunctionExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterConstIntIdExpression

          public void enterConstIntIdExpression​(DmlParser.ConstIntIdExpressionContext ctx)

      Enter a parse tree produced by the `ConstIntIdExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterConstIntIdExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitConstIntIdExpression

          public void exitConstIntIdExpression​(DmlParser.ConstIntIdExpressionContext ctx)

      Exit a parse tree produced by the `ConstIntIdExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitConstIntIdExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterAtomicExpression

          public void enterAtomicExpression​(DmlParser.AtomicExpressionContext ctx)

      Enter a parse tree produced by the `AtomicExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterAtomicExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitAtomicExpression

          public void exitAtomicExpression​(DmlParser.AtomicExpressionContext ctx)

      Exit a parse tree produced by the `AtomicExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitAtomicExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterConstStringIdExpression

          public void enterConstStringIdExpression​(DmlParser.ConstStringIdExpressionContext ctx)

      Enter a parse tree produced by the `ConstStringIdExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterConstStringIdExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitConstStringIdExpression

          public void exitConstStringIdExpression​(DmlParser.ConstStringIdExpressionContext ctx)

      Exit a parse tree produced by the `ConstStringIdExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitConstStringIdExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterConstTrueExpression

          public void enterConstTrueExpression​(DmlParser.ConstTrueExpressionContext ctx)

      Enter a parse tree produced by the `ConstTrueExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterConstTrueExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitConstTrueExpression

          public void exitConstTrueExpression​(DmlParser.ConstTrueExpressionContext ctx)

      Exit a parse tree produced by the `ConstTrueExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitConstTrueExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterUnaryExpression

          public void enterUnaryExpression​(DmlParser.UnaryExpressionContext ctx)

      Enter a parse tree produced by the `UnaryExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterUnaryExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitUnaryExpression

          public void exitUnaryExpression​(DmlParser.UnaryExpressionContext ctx)

      Exit a parse tree produced by the `UnaryExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitUnaryExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterMultDivExpression

          public void enterMultDivExpression​(DmlParser.MultDivExpressionContext ctx)

      Enter a parse tree produced by the `MultDivExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterMultDivExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitMultDivExpression

          public void exitMultDivExpression​(DmlParser.MultDivExpressionContext ctx)

      Exit a parse tree produced by the `MultDivExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitMultDivExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterConstFalseExpression

          public void enterConstFalseExpression​(DmlParser.ConstFalseExpressionContext ctx)

      Enter a parse tree produced by the `ConstFalseExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterConstFalseExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitConstFalseExpression

          public void exitConstFalseExpression​(DmlParser.ConstFalseExpressionContext ctx)

      Exit a parse tree produced by the `ConstFalseExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitConstFalseExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterDataIdExpression

          public void enterDataIdExpression​(DmlParser.DataIdExpressionContext ctx)

      Enter a parse tree produced by the `DataIdExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterDataIdExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitDataIdExpression

          public void exitDataIdExpression​(DmlParser.DataIdExpressionContext ctx)

      Exit a parse tree produced by the `DataIdExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitDataIdExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterAddSubExpression

          public void enterAddSubExpression​(DmlParser.AddSubExpressionContext ctx)

      Enter a parse tree produced by the `AddSubExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterAddSubExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitAddSubExpression

          public void exitAddSubExpression​(DmlParser.AddSubExpressionContext ctx)

      Exit a parse tree produced by the `AddSubExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitAddSubExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterConstDoubleIdExpression

          public void enterConstDoubleIdExpression​(DmlParser.ConstDoubleIdExpressionContext ctx)

      Enter a parse tree produced by the `ConstDoubleIdExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterConstDoubleIdExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitConstDoubleIdExpression

          public void exitConstDoubleIdExpression​(DmlParser.ConstDoubleIdExpressionContext ctx)

      Exit a parse tree produced by the `ConstDoubleIdExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitConstDoubleIdExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterMatrixMulExpression

          public void enterMatrixMulExpression​(DmlParser.MatrixMulExpressionContext ctx)

      Enter a parse tree produced by the `MatrixMulExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterMatrixMulExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitMatrixMulExpression

          public void exitMatrixMulExpression​(DmlParser.MatrixMulExpressionContext ctx)

      Exit a parse tree produced by the `MatrixMulExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitMatrixMulExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterMultiIdExpression

          public void enterMultiIdExpression​(DmlParser.MultiIdExpressionContext ctx)

      Enter a parse tree produced by the `MultiIdExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterMultiIdExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitMultiIdExpression

          public void exitMultiIdExpression​(DmlParser.MultiIdExpressionContext ctx)

      Exit a parse tree produced by the `MultiIdExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitMultiIdExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterBooleanAndExpression

          public void enterBooleanAndExpression​(DmlParser.BooleanAndExpressionContext ctx)

      Enter a parse tree produced by the `BooleanAndExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterBooleanAndExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitBooleanAndExpression

          public void exitBooleanAndExpression​(DmlParser.BooleanAndExpressionContext ctx)

      Exit a parse tree produced by the `BooleanAndExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitBooleanAndExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterBooleanOrExpression

          public void enterBooleanOrExpression​(DmlParser.BooleanOrExpressionContext ctx)

      Enter a parse tree produced by the `BooleanOrExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `enterBooleanOrExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitBooleanOrExpression

          public void exitBooleanOrExpression​(DmlParser.BooleanOrExpressionContext ctx)

      Exit a parse tree produced by the `BooleanOrExpression` labeled alternative in `DmlParser.expression()`.

      The default implementation does nothing.

      Specified by:
        `exitBooleanOrExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterTypedArgNoAssign

          public void enterTypedArgNoAssign​(DmlParser.TypedArgNoAssignContext ctx)

      Enter a parse tree produced by `DmlParser.typedArgNoAssign()`.

      The default implementation does nothing.

      Specified by:
        `enterTypedArgNoAssign` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitTypedArgNoAssign

          public void exitTypedArgNoAssign​(DmlParser.TypedArgNoAssignContext ctx)

      Exit a parse tree produced by `DmlParser.typedArgNoAssign()`.

      The default implementation does nothing.

      Specified by:
        `exitTypedArgNoAssign` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterTypedArgAssign

          public void enterTypedArgAssign​(DmlParser.TypedArgAssignContext ctx)

      Enter a parse tree produced by `DmlParser.typedArgAssign()`.

      The default implementation does nothing.

      Specified by:
        `enterTypedArgAssign` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitTypedArgAssign

          public void exitTypedArgAssign​(DmlParser.TypedArgAssignContext ctx)

      Exit a parse tree produced by `DmlParser.typedArgAssign()`.

      The default implementation does nothing.

      Specified by:
        `exitTypedArgAssign` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterParameterizedExpression

          public void enterParameterizedExpression​(DmlParser.ParameterizedExpressionContext ctx)

      Enter a parse tree produced by `DmlParser.parameterizedExpression()`.

      The default implementation does nothing.

      Specified by:
        `enterParameterizedExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitParameterizedExpression

          public void exitParameterizedExpression​(DmlParser.ParameterizedExpressionContext ctx)

      Exit a parse tree produced by `DmlParser.parameterizedExpression()`.

      The default implementation does nothing.

      Specified by:
        `exitParameterizedExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterStrictParameterizedExpression

          public void enterStrictParameterizedExpression​(DmlParser.StrictParameterizedExpressionContext ctx)

      Enter a parse tree produced by `DmlParser.strictParameterizedExpression()`.

      The default implementation does nothing.

      Specified by:
        `enterStrictParameterizedExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitStrictParameterizedExpression

          public void exitStrictParameterizedExpression​(DmlParser.StrictParameterizedExpressionContext ctx)

      Exit a parse tree produced by `DmlParser.strictParameterizedExpression()`.

      The default implementation does nothing.

      Specified by:
        `exitStrictParameterizedExpression` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterStrictParameterizedKeyValueString

          public void enterStrictParameterizedKeyValueString​(DmlParser.StrictParameterizedKeyValueStringContext ctx)

      Enter a parse tree produced by `DmlParser.strictParameterizedKeyValueString()`.

      The default implementation does nothing.

      Specified by:
        `enterStrictParameterizedKeyValueString` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitStrictParameterizedKeyValueString

          public void exitStrictParameterizedKeyValueString​(DmlParser.StrictParameterizedKeyValueStringContext ctx)

      Exit a parse tree produced by `DmlParser.strictParameterizedKeyValueString()`.

      The default implementation does nothing.

      Specified by:
        `exitStrictParameterizedKeyValueString` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterMl_type

          public void enterMl_type​(DmlParser.Ml_typeContext ctx)

      Enter a parse tree produced by `DmlParser.ml_type()`.

      The default implementation does nothing.

      Specified by:
        `enterMl_type` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitMl_type

          public void exitMl_type​(DmlParser.Ml_typeContext ctx)

      Exit a parse tree produced by `DmlParser.ml_type()`.

      The default implementation does nothing.

      Specified by:
        `exitMl_type` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterValueType

          public void enterValueType​(DmlParser.ValueTypeContext ctx)

      Enter a parse tree produced by `DmlParser.valueType()`.

      The default implementation does nothing.

      Specified by:
        `enterValueType` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitValueType

          public void exitValueType​(DmlParser.ValueTypeContext ctx)

      Exit a parse tree produced by `DmlParser.valueType()`.

      The default implementation does nothing.

      Specified by:
        `exitValueType` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterMatrixDataTypeCheck

          public void enterMatrixDataTypeCheck​(DmlParser.MatrixDataTypeCheckContext ctx)

      Enter a parse tree produced by the `MatrixDataTypeCheck` labeled alternative in `DmlParser.dataType()`.

      The default implementation does nothing.

      Specified by:
        `enterMatrixDataTypeCheck` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### exitMatrixDataTypeCheck

          public void exitMatrixDataTypeCheck​(DmlParser.MatrixDataTypeCheckContext ctx)

      Exit a parse tree produced by the `MatrixDataTypeCheck` labeled alternative in `DmlParser.dataType()`.

      The default implementation does nothing.

      Specified by:
        `exitMatrixDataTypeCheck` in interface `DmlListener`
      Parameters:
        `ctx` - the parse tree

    - #### enterEveryRule

          public void enterEveryRule​(org.antlr.v4.runtime.ParserRuleContext ctx)

      The default implementation does nothing.

      Specified by:
        `enterEveryRule` in interface `org.antlr.v4.runtime.tree.ParseTreeListener`

    - #### exitEveryRule

          public void exitEveryRule​(org.antlr.v4.runtime.ParserRuleContext ctx)

      The default implementation does nothing.

      Specified by:
        `exitEveryRule` in interface `org.antlr.v4.runtime.tree.ParseTreeListener`

    - #### visitTerminal

          public void visitTerminal​(org.antlr.v4.runtime.tree.TerminalNode node)

      The default implementation does nothing.

      Specified by:
        `visitTerminal` in interface `org.antlr.v4.runtime.tree.ParseTreeListener`

    - #### visitErrorNode

          public void visitErrorNode​(org.antlr.v4.runtime.tree.ErrorNode node)

      The default implementation does nothing.

      Specified by:
        `visitErrorNode` in interface `org.antlr.v4.runtime.tree.ParseTreeListener`